/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-roseus-1.3.9-0raring-20150915-0110/msg/FixedArray.msg
 *
 */


#ifndef ROSEUS_MESSAGE_FIXEDARRAY_H
#define ROSEUS_MESSAGE_FIXEDARRAY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace roseus
{
template <class ContainerAllocator>
struct FixedArray_
{
  typedef FixedArray_<ContainerAllocator> Type;

  FixedArray_()
    : float32_data()
    , float64_data()
    , int16_data()
    , int32_data()
    , int64_data()
    , int8_data()
    , uint16_data()
    , uint32_data()
    , uint64_data()
    , uint8_data()  {
      float32_data.assign(0.0);

      float64_data.assign(0.0);

      int16_data.assign(0);

      int32_data.assign(0);

      int64_data.assign(0);

      int8_data.assign(0);

      uint16_data.assign(0);

      uint32_data.assign(0);

      uint64_data.assign(0);

      uint8_data.assign(0);
  }
  FixedArray_(const ContainerAllocator& _alloc)
    : float32_data()
    , float64_data()
    , int16_data()
    , int32_data()
    , int64_data()
    , int8_data()
    , uint16_data()
    , uint32_data()
    , uint64_data()
    , uint8_data()  {
      float32_data.assign(0.0);

      float64_data.assign(0.0);

      int16_data.assign(0);

      int32_data.assign(0);

      int64_data.assign(0);

      int8_data.assign(0);

      uint16_data.assign(0);

      uint32_data.assign(0);

      uint64_data.assign(0);

      uint8_data.assign(0);
  }



   typedef boost::array<float, 3>  _float32_data_type;
  _float32_data_type float32_data;

   typedef boost::array<double, 3>  _float64_data_type;
  _float64_data_type float64_data;

   typedef boost::array<int16_t, 3>  _int16_data_type;
  _int16_data_type int16_data;

   typedef boost::array<int32_t, 3>  _int32_data_type;
  _int32_data_type int32_data;

   typedef boost::array<int64_t, 3>  _int64_data_type;
  _int64_data_type int64_data;

   typedef boost::array<int8_t, 3>  _int8_data_type;
  _int8_data_type int8_data;

   typedef boost::array<uint16_t, 3>  _uint16_data_type;
  _uint16_data_type uint16_data;

   typedef boost::array<uint32_t, 3>  _uint32_data_type;
  _uint32_data_type uint32_data;

   typedef boost::array<uint64_t, 3>  _uint64_data_type;
  _uint64_data_type uint64_data;

   typedef boost::array<uint8_t, 17>  _uint8_data_type;
  _uint8_data_type uint8_data;




  typedef boost::shared_ptr< ::roseus::FixedArray_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::roseus::FixedArray_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct FixedArray_

typedef ::roseus::FixedArray_<std::allocator<void> > FixedArray;

typedef boost::shared_ptr< ::roseus::FixedArray > FixedArrayPtr;
typedef boost::shared_ptr< ::roseus::FixedArray const> FixedArrayConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::roseus::FixedArray_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::roseus::FixedArray_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace roseus

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'roseus': ['/tmp/buildd/ros-hydro-roseus-1.3.9-0raring-20150915-0110/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::roseus::FixedArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::roseus::FixedArray_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::roseus::FixedArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::roseus::FixedArray_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::roseus::FixedArray_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::roseus::FixedArray_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::roseus::FixedArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7ea1165c6f2f41b3c4b266b09959a7e4";
  }

  static const char* value(const ::roseus::FixedArray_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7ea1165c6f2f41b3ULL;
  static const uint64_t static_value2 = 0xc4b266b09959a7e4ULL;
};

template<class ContainerAllocator>
struct DataType< ::roseus::FixedArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "roseus/FixedArray";
  }

  static const char* value(const ::roseus::FixedArray_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::roseus::FixedArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# This message is only for geneus test\n\
float32[3]  float32_data\n\
float64[3]  float64_data\n\
  int16[3]  int16_data\n\
  int32[3]  int32_data\n\
  int64[3]  int64_data\n\
   int8[3]  int8_data\n\
 uint16[3]  uint16_data\n\
 uint32[3]  uint32_data\n\
 uint64[3]  uint64_data\n\
  uint8[17] uint8_data\n\
";
  }

  static const char* value(const ::roseus::FixedArray_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::roseus::FixedArray_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.float32_data);
      stream.next(m.float64_data);
      stream.next(m.int16_data);
      stream.next(m.int32_data);
      stream.next(m.int64_data);
      stream.next(m.int8_data);
      stream.next(m.uint16_data);
      stream.next(m.uint32_data);
      stream.next(m.uint64_data);
      stream.next(m.uint8_data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct FixedArray_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::roseus::FixedArray_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::roseus::FixedArray_<ContainerAllocator>& v)
  {
    s << indent << "float32_data[]" << std::endl;
    for (size_t i = 0; i < v.float32_data.size(); ++i)
    {
      s << indent << "  float32_data[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.float32_data[i]);
    }
    s << indent << "float64_data[]" << std::endl;
    for (size_t i = 0; i < v.float64_data.size(); ++i)
    {
      s << indent << "  float64_data[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.float64_data[i]);
    }
    s << indent << "int16_data[]" << std::endl;
    for (size_t i = 0; i < v.int16_data.size(); ++i)
    {
      s << indent << "  int16_data[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.int16_data[i]);
    }
    s << indent << "int32_data[]" << std::endl;
    for (size_t i = 0; i < v.int32_data.size(); ++i)
    {
      s << indent << "  int32_data[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.int32_data[i]);
    }
    s << indent << "int64_data[]" << std::endl;
    for (size_t i = 0; i < v.int64_data.size(); ++i)
    {
      s << indent << "  int64_data[" << i << "]: ";
      Printer<int64_t>::stream(s, indent + "  ", v.int64_data[i]);
    }
    s << indent << "int8_data[]" << std::endl;
    for (size_t i = 0; i < v.int8_data.size(); ++i)
    {
      s << indent << "  int8_data[" << i << "]: ";
      Printer<int8_t>::stream(s, indent + "  ", v.int8_data[i]);
    }
    s << indent << "uint16_data[]" << std::endl;
    for (size_t i = 0; i < v.uint16_data.size(); ++i)
    {
      s << indent << "  uint16_data[" << i << "]: ";
      Printer<uint16_t>::stream(s, indent + "  ", v.uint16_data[i]);
    }
    s << indent << "uint32_data[]" << std::endl;
    for (size_t i = 0; i < v.uint32_data.size(); ++i)
    {
      s << indent << "  uint32_data[" << i << "]: ";
      Printer<uint32_t>::stream(s, indent + "  ", v.uint32_data[i]);
    }
    s << indent << "uint64_data[]" << std::endl;
    for (size_t i = 0; i < v.uint64_data.size(); ++i)
    {
      s << indent << "  uint64_data[" << i << "]: ";
      Printer<uint64_t>::stream(s, indent + "  ", v.uint64_data[i]);
    }
    s << indent << "uint8_data[]" << std::endl;
    for (size_t i = 0; i < v.uint8_data.size(); ++i)
    {
      s << indent << "  uint8_data[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.uint8_data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROSEUS_MESSAGE_FIXEDARRAY_H
